/*
 * Glue for Ada<->ERL interface
 */

#include <erl_interface.h>
#include <ei.h>

#define ETERM_INTEGER           0
#define ETERM_UNSIGNED_INTEGER  1
#define ETERM_FLOAT             2
#define ETERM_ATOM              3
#define ETERM_PID               4
#define ETERM_PORT              5
#define ETERM_REF               6
#define ETERM_TUPLE             7
#define ETERM_BINARY            8
#define ETERM_EMPTY_LIST        9
#define ETERM_CONS             10
#define ETERM_UNKNOWN          11

int
ada_erl_kind (ETERM *term)
{
  if (ERL_IS_INTEGER (term))
    return ETERM_INTEGER;
  if (ERL_IS_UNSIGNED_INTEGER (term))
    return ETERM_UNSIGNED_INTEGER;
  if (ERL_IS_FLOAT (term))
    return ETERM_FLOAT;
  if (ERL_IS_ATOM (term))
    return ETERM_ATOM;
  if (ERL_IS_PID (term))
    return ETERM_PID;
  if (ERL_IS_PORT (term))
    return ETERM_PORT;
  if (ERL_IS_REF (term))
    return ETERM_REF;
  if (ERL_IS_TUPLE (term))
    return ETERM_TUPLE;
  if (ERL_IS_BINARY (term))
    return ETERM_BINARY;
  if (ERL_IS_EMPTY_LIST (term))
    return ETERM_EMPTY_LIST;
  if (ERL_IS_CONS (term))
    return ETERM_CONS;
  return ETERM_UNKNOWN;
}

int
ada_erl_int_value (ETERM *term)
{
  return ERL_INT_VALUE (term);
}

int
ada_erl_int_uvalue (ETERM *term)
{
  return ERL_INT_UVALUE (term);
}

int
ada_erl_bin_size (ETERM *term)
{
  return ERL_BIN_SIZE (term);
}

int
ada_erl_pid_creation (ETERM *term)
{
  return ERL_PID_CREATION (term);
}

int
ada_erl_port_creation (ETERM *term)
{
  return ERL_PORT_CREATION (term);
}

char *
ada_erl_atom_ptr (ETERM *term)
{
  return ERL_ATOM_PTR (term);
}

double
ada_erl_float_value (ETERM *term)
{
  return ERL_FLOAT_VALUE (term);
}

void *
ada_erl_bin_ptr (ETERM *term)
{
  return ERL_BIN_PTR (term);
}

char *
ada_erl_pid_node (ETERM *term)
{
  return ERL_PID_NODE (term);
}

char *
ada_erl_port_node (ETERM *term)
{
  return ERL_PORT_NODE (term);
}

int
ada_erl_pid_number (ETERM *term)
{
  return ERL_PID_NUMBER (term);
}

int
ada_erl_port_number (ETERM *term)
{
  return ERL_PORT_NUMBER (term);
}

int
ada_erl_pid_serial (ETERM *term)
{
  return ERL_PID_SERIAL (term);
}

int
ada_erl_tuple_size (ETERM *term)
{
  return ERL_TUPLE_SIZE (term);
}

void
ada_erl_init ()
{
  erl_init (NULL, 0);
}
