with Erl_Interface.Erl_Format; use Erl_Interface.Erl_Format;

package body Erl_Utils is

   -----------
   -- Image --
   -----------

   function Image (FD : File_Descriptor; Term : access Eterm) return String is
      Format    : aliased Format_Stream;
      Term_Copy : Eterm_Ptr := Copy (Term);
      Query     : Eterm_Ptr;
      Answer    : Eterm_Ptr;
   begin
      Initialize (Format'Access, "[~s, [~w]]");
      String'Output (Format'Access, "~p");
      Eterm_Ptr'Output (Format'Access, Term_Copy);
      Query  := Compute (Format'Access);
      Answer := Erl_RPC (FD, "io_lib", "format", Query);
      declare
         Result : constant String := Get (Answer);
      begin
         Free_Compound (Query);
         Free_Compound (Answer);
         return Result;
      end;
   end Image;

end Erl_Utils;
