with Ada.Command_Line;          use Ada.Command_Line;
with Ada.Text_IO;               use Ada.Text_IO;
with Erl_Interface.Erl_Connect; use Erl_Interface.Erl_Connect;
with Erl_Interface.Erl_Eterm;   use Erl_Interface.Erl_Eterm;
with Erl_Interface.Erl_Format;  use Erl_Interface.Erl_Format;
with Erl_Utils;                 use Erl_Utils;

procedure Test is

   FD     : File_Descriptor;
   Query  : Eterm_Ptr;
   Format : aliased Format_Stream;

   procedure Do_Remote_Call
     (Module : in String; Func : in String; Args : in out Eterm_Ptr);

   --------------------
   -- Do_Remote_Call --
   --------------------

   procedure Do_Remote_Call
     (Module : in String; Func : in String; Args : in out Eterm_Ptr)
   is
      Result : Eterm_Ptr;
   begin
      Put_Line ("Attempting to call {" & Module & ", " & Func & ", " &
                Image (FD, Args) & "}");
      Result := Erl_RPC (FD, Module, Func, Args);
      Put_Line ("Result is: ");
      Put_Line (Image (Fd, Result));
      Free_Compound (Result);
      Free_Compound (Args);
   end Do_Remote_Call;

begin
   Erl_Connect_Init (1, "cookie", 1);
   FD := Erl_Connect ("sam@localhost");

   Initialize (Format'Access, "[~s, [~s]]");
   String'Output (Format'Access, "The user said: <<~s>>~n");
   String'Output (Format'Access, Argument (1));
   Query := Compute (Format'Access);
   Do_Remote_Call ("io", "format", Query);
   Free (Query);

   Query := Make_Empty_List;
   Do_Remote_Call ("erlang", "registered", Query);
   Free (Query);

end Test;
